Bug 48325 - Не работает gem server
Summary: Не работает gem server
Status: REOPENED
Alias: None
Product: Sisyphus
Classification: Development
Component: gem (show other bugs)
Version: unstable
Hardware: x86_64 Linux
: P5 normal
Assignee: majioa@altlinux.org
QA Contact: qa-sisyphus
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2023-11-03 15:59 MSK by Alexander Makeenkov
Modified: 2024-02-12 15:03 MSK (History)
10 users (show)

See Also:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Alexander Makeenkov 2023-11-03 15:59:24 MSK
Шаги воспроизведения:
# apt-get install gem
$ gem server

Получаемый результат:
ERROR:  Install the rubygems-server gem for the server command

$ apt-cache search rubygems-server | wc
      0       0       0

$ rpm -qa | grep -E "ruby|gem"
gem-power-assert-2.0.1-alt1.noarch
gem-xmlrpc-0.3.2-alt1.1.noarch
ruby-stdlibs-3.1.2-alt2.1.x86_64
libruby-3.1.2-alt2.1.x86_64
gem-net-telnet-0.2.0.1-alt0.1.noarch
gem-rake-13.0.6-alt1.noarch
gem-webrick-1.7.0-alt1.noarch
ruby-3.1.2-alt2.1.x86_64
gem-3.3.7-alt2.1.noarch
gem-minitest-5.18.1-alt1.noarch
gem-test-unit-3.5.3-alt1.noarch
gem-rdoc-6.4.0.1-alt1.noarch
gem-bundler-2.2.19-alt1.noarch
Comment 1 Малъ Скрылевъ 2023-11-03 19:50:18 MSK
apt-cache search rubygems-server и не долженъ ничего показывать, на него въ тестахъ оріентироваться не стоитъ.... :)

Чторонніе gem-ы должны устанавливаться въ /var/cache, если не такъ, значиъ это ошибка и я буду смотрѣть.
Comment 2 Малъ Скрылевъ 2023-11-03 19:51:23 MSK
apt-cache search rubygems-server и не долженъ ничего показывать, на него въ тестахъ оріентироваться не стоитъ.... :)

Сторонніе gem-ы должны устанавливаться въ /var/cache, если не такъ, значитъ это ошибка и я буду смотрѣть.
Comment 3 Alexander Makeenkov 2023-11-03 20:10:01 MSK
(Ответ для Малъ Скрылевъ на комментарий #2)
> apt-cache search rubygems-server и не долженъ ничего показывать, на него въ
> тестахъ оріентироваться не стоитъ.... :)
> 
> Сторонніе gem-ы должны устанавливаться въ /var/cache, если не такъ, значитъ
> это ошибка и я буду смотрѣть.

Вот только сторонние модули сейчас вообще никак нельзя установить из-за https://bugzilla.altlinux.org/47660
Comment 4 Alexander Makeenkov 2023-11-03 20:18:45 MSK
И да, в версии 3.1.6 такой проблемы нет:

$ rpm -q gem && gem server
gem-3.1.6-alt1.1.noarch
Server started at http://0.0.0.0:8808
Server started at http://[::]:8808

$ rpm -qa | grep -E "ruby|gem"
gem-power-assert-1.1.7-alt1.noarch
gem-minitest-5.14.1-alt0.1.noarch
ruby-rdoc-6.1.1-alt3.noarch
gem-ruby-ldap-0.9.20-alt4.2.x86_64
gem-3.1.6-alt1.1.noarch
ruby-2.7.4-alt2.2.1.x86_64
ruby-net-telnet-0.2.0-alt1.noarch
gem-bundler-2.1.4-alt1.noarch
gem-test-unit-3.3.5-alt1.noarch
gem-rake-13.0.1-alt1.noarch
libruby-2.7.4-alt2.2.1.x86_64
ruby-stdlibs-2.7.4-alt2.2.1.x86_64
ruby-xmlrpc-0.3.0-alt1.noarch
Comment 5 Малъ Скрылевъ 2023-11-04 12:37:40 MSK
И хотя я согласенъ съ наличиемъ проблемы, и анализирую лучшее рѣшеніе, но если говорить именно про рубишниковъ, то для установки стороннихъ библзотекъ въ сообществѣ принято пользоваться rvm/rbenv.
Comment 6 Repository Robot 2023-12-14 01:51:15 MSK
ruby-3.1.4-alt1 -> sisyphus:

 Mon Nov 13 2023 Pavel Skrylev <majioa@altlinux> 3.1.4-alt1
 - ^ 3.1.2 -> 3.1.4 (closes #47868)
 - * moved build to rvm
 - * BREAK: changed some things to rpm-build-macros
 - ! fixed:
  + CVE-2022-39253 for bundler
  + enabled permissions to /var/lib/ruby/gemie/ (closes #45251)
  + enable running gemserver (closes #48325)
  + custom gem installation (closes #47660)
  + loading ruby's so libraries (closes #48249)
  + drop explicit dependencies to libs including ssl1.1 (closes #48713)
Comment 7 Alexander Makeenkov 2024-02-07 13:07:37 MSK
Версии пакетов:
ruby-3.1.4-alt2.1.x86_64
gem-3.3.26-alt2.1.noarch
gem-rubygems-server-0.3.0-alt1.noarch

Ошибка воспроизводится:
$ gem server
ERROR:  Install the rubygems-server gem for the server command

Не смотря на то, что пакет gem-rubygems-server установлен:
$ rpm -q gem-rubygems-server
gem-rubygems-server-0.3.0-alt1.noarch
Comment 8 Repository Robot 2024-02-11 09:54:24 MSK
ruby-3.1.4-alt3 -> sisyphus:

 Wed Feb 07 2024 Pavel Skrylev <majioa@altlinux> 3.1.4-alt3
 - + allow access to gem cache for ruby group instead of rvm (closes #48325)
 - * rearranged load path (closes #48249)
Comment 9 Alexander Makeenkov 2024-02-12 12:21:00 MSK
# apt-get install ruby gem gem-rubygems-server

# rpm -q ruby gem gem-rubygems-server
ruby-3.1.4-alt3.x86_64
gem-3.3.26-alt3.noarch
gem-rubygems-server-0.3.0-alt1.noarch

$ gem server
ERROR:  Install the rubygems-server gem for the server command
Comment 10 Малъ Скрылевъ 2024-02-12 14:13:41 MSK
please refer to: https://en.altlinux.org/Ruby/Usage
Comment 11 Alexander Makeenkov 2024-02-12 14:47:16 MSK
(Ответ для Малъ Скрылевъ на комментарий #10)
> please refer to: https://en.altlinux.org/Ruby/Usage

ok:

# apt-get install ruby

# gem server
ERROR:  Install the rubygems-server gem for the server command

# apt-get install gem-rubygems-server

# rpm -q gem-rubygems-server && gem server
gem-rubygems-server-0.3.0-alt1.noarch
ERROR:  Install the rubygems-server gem for the server command

# usermod test -aG ruby && su - test

$ id
uid=500(test) gid=500(test) группы=500(test),10(wheel),100(users),467(ruby)

$ gem server
ERROR:  Install the rubygems-server gem for the server command
Comment 12 Малъ Скрылевъ 2024-02-12 14:53:09 MSK
# gem install rubygems-server 
Fetching webrick-1.8.1.gem
Fetching rubygems-server-0.3.0.gem
Successfully installed webrick-1.8.1
Successfully installed rubygems-server-0.3.0
Parsing documentation for webrick-1.8.1
Installing ri documentation for webrick-1.8.1
Parsing documentation for rubygems-server-0.3.0
Installing ri documentation for rubygems-server-0.3.0
Done installing documentation for webrick, rubygems-server after 2 seconds
2 gems installed
root@predvridlo ~ # gem server
Server started at http://0.0.0.0:8808
Server started at http://[::]:8808
^Croot@predvridlo ~ # 
exit
majioa@predvridlo ~ $ gem server
Server started at http://0.0.0.0:8808
Server started at http://[::]:8808
$ apt-cache show ruby
 * Ср фев 07 2024 Pavel Skrylev <majioa@altlinux.org> 3.1.4-alt3
Comment 13 Anton Farygin 2024-02-12 15:03:58 MSK
тогда надо удалять пакет gem-rubygems-server